﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System.Text
Imports System.Math
Imports System.Double

Friend Module ServiceMnb

    Friend n As Integer 'число переменных
    Friend alfa As Double 'параметр Alfa (0,0 < Alfa <0,5) рекомендуется выбирать равным 0,4
    Friend nr As Integer 'nr <= 400 - число "правильных разрядов" функции F(x) в точке, полученной на итерации k = 0,...,kmax. Обычно величину nr (nr <= 400) рекомендуется выбирать равной 48
    Friend kmax As Integer 'максимальное количество итераций
    Friend xk() As Double 'стартовая точка на итерации k
    Friend sF As String 'текстовое описание функции
    Friend balternative As Boolean 'True -> c альтернативным направлением спуска
    Friend mex As Integer 'максимальное число вычислений альтернативного направления спуска. Обычно величину mex рекомендуется выбирать равной 12
    Friend beta As Double '(оценивание конечно-разностных интервалов), обычно величину beta рекомендуется выбирать из интервала 0.000 001 <= beta <= 0.000 0001
    Friend gamma As Double '(оценивание конечно-разностных интервалов). Обычно величину gamma рекомендуется выбирать из интервала 5 <= gamma <= 10
    'выходные параметры
    Friend berror As Boolean 'признак ошибки при описании параметров задачи
    Friend k As Integer 'номер итерации
    Friend h() As Double 'массив относительных конечно-разностных интервалов
    Friend Fk As Double 'значение минимизируемой функции на итерации k
    Friend n0 As Integer = 0 'число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений
    Friend no As Integer = 0 'число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений
    Friend ns As Integer = 0 'число поисков направления отрицательной кривизны
    Friend na As Integer = 0 'число переходов к альтернативному направлению спуска
    Friend nau As Integer = 0 'число успешных переходов к альтернативному направлению спуска
    Friend nf As Integer 'число вычисений фуккции

    Friend Sub Mnb()
        'подпрограмма квазиньютоновского метода безусловной минимизации не обязательно выпуклой функции F(x)
        'с конечно-разностной аппроксимацией первых и вторых производных F(x)
        'подход Хакимовой путем продолжения построения подхода Гилла и Мюррея
        Dim hi(n - 1) As Double 'градиент
        Dim Hij((n * (n + 1)) \ 2 - 1) As Double 'матрица вторых производных
        Dim Fk1 As Double 'значение минимизируемой функции на итерации k + 1
        Dim rFk As Double 'Fk - Fk1
        Dim xk1(n - 1) As Double 'стартовая точка на итерации k + 1
        Dim pk(n - 1) As Double 'направление спуска
        Dim epsh As Double 'оценка близости нормы градинта к нулю
        Dim epsv As Double 'оценка критерия останова по скорости сходимости
        Dim bhi As Boolean 'True -> Abs(hi(i)) < epsh
        Dim hp As Double 'производная по направлению
        If nr > 400 Then
            bMessage(1, globProblem, "Задано слишком большое число правильных разрядов nr", False)
            berror = True
            Exit Sub
        End If
        Dim tf As Double = 2 ^ -nr
        Dim t0 As Double = 2 ^ (-nr / 2)
        Dim th As Double = 2 ^ (-nr / 3)
        Dim nstop As Integer 'признак останова: 0 - по близости нормы градинта к нулю, 1 - по числу итераций kmax, 2 - по скорости сходимости
        'альтернативное направление спуска 
        Dim ex(n - 1, 3) As Double 'стартовые точки ex(i, iex), i = 0, ..., n - 1, iex = 0, 1, 2
        Dim iex As Integer = 0 'индекс стартовой точки ex(i, iex), i = 0, ..., n - 1
        Dim nex As Integer '-1 -> неоределенность, 0 -> Fk1 < Fk, 1 -> Fk1 > Fk
        Dim bex As Boolean 'признак вычисления направления спуска
        'положить n0 = 0, no = 0, ns = 0, na = 0, nau = 0
        n0 = 0 'число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений
        no = 0 'число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений
        ns = 0 'число поисков направления отрицательной кривизны
        na = 0 'число переходов к альтернативному направлению спуска
        nau = 0 'число успешных переходов к альтернативному направлению спуска
        'положить rFk = 0, nstop = 1, bex = balternative
        rFk = 0
        nstop = 1
        bex = balternative
        '
        Dim hi1(n - 1) As Double 'градиент на итерации k + 1
        Dim yi(n - 1) As Double 'hi1(i) -hi(i) 
        Dim alfak As Double 'xk1(i) = xk(i) + alfak * pk(i)
        Dim c As Double 'константа для пересчета факторов Холесского
        Dim z(n - 1) As Double 'вектор для пересчета факторов Холесского
        Dim Hijold((n * (n + 1)) \ 2 - 1) As Double 'матрица вторых производных
        Dim mm As Integer = -1 'число переходов к ньютоновскому направлению спуска
        Dim m As Integer = 1
        'вычислить значение функции и аргументы
        Dim i As Integer
        For kiter = 1 To kmax
            k = kiter
            'вычислить hi(i), Hij(i,j)
            If k = m Then
                mm += 1
                m = k + intIntegrationSteps
                Call ApproximationDerivatives(hi, 1, Hij)
                For i = 0 To (n * (n + 1)) \ 2 - 1
                    Hijold(i) = Hij(i)
                Next
            Else
                For i = 0 To (n * (n + 1)) \ 2 - 1
                    Hij(i) = Hijold(i)
                Next
            End If
            'вычислить epsh
            epsh = th * (1 + Abs(rFk))
            'вычислить bhi, bhi = True -> Abs(hi(i)) < epsh
            bhi = bh(hi, epsh)
            'положить pk(i) = -hi(i)
            For i = 0 To n - 1
                pk(i) = -hi(i)
            Next
            'вычислить u, U, D
            Call uUD(Hij, pk, t0, bh(hi, t0))
            'проверить условие успешного окончания счета
            If bhi Then
                nstop = 0 'признак останова по близости нормы градинта к нулю
                Exit For
            End If
            'вычислить pk
            Call p(Hij, pk)
            hp = 0
            For i = 0 To n - 1
                hp += hi(i) * pk(i)
                xk1(i) = xk(i) + pk(i)
            Next
            Fk1 = func(sF, xk1, False)
            If berror Then
                'окончание счета по скорости сходимости
                berror = False
                nstop = 2
                Exit For
            End If
            nf += 1
            alfak = 1
            If Fk1 - Fk > alfa * hp Then
                'вычислить xk1, Fk1
                Call fib(21, Fk1, xk1, pk, alfak, hp, 0, 1)
            End If
            'вычислить rFk = Fk - Fk1
            rFk = Fk - Fk1
            If rFk < 0 Then
                'окончание счета по скорости сходимости
                nstop = 2
                Exit For
            End If
            'вычислить epsv
            epsv = tf * (1 + Abs(rFk))
            'положить Fk = Fk1, xk = xk1
            Fk = Fk1
            For i = 0 To n - 1
                xk(i) = xk1(i)
            Next
            'построение альтернативного направления спуска
            If balternative Then Call Extrapolation(iex, ex, pk, bex, nex)
            If berror Then
                berror = False
                Fk = Fk1
                For i = 0 To n - 1
                    xk(i) = xk1(i)
                Next
            End If
            If rFk < epsv Then
                'окончание счета по скорости сходимости
                nstop = 2
                Exit For
            End If
            Call ApproximationDerivatives(hi1, 0)
            For i = 0 To n - 1
                yi(i) = hi1(i) - hi(i)
            Next
            'Формулы пересчета аппроксимации матрицы вторых производных
            Dim j, jj As Integer
            Dim dj As Double
            Dim djj As Double
            Select Case strFormula
                Case "Симметричная формула ранга один"
                    c = 0
                    For i = 0 To n - 1
                        z(i) = yi(i) + alfak * hi(i)
                        c += z(i) * pk(i)
                    Next
                    c *= alfak
                    jj = 0
                    For j = 0 To n - 1
                        dj = z(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (z(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                Case "PSB-формула"
                    c = 0
                    For i = 0 To n - 1
                        z(i) = yi(i) + alfak * hi(i)
                        c += pk(i) * pk(i)
                    Next
                    c *= alfak
                    jj = 0
                    For j = 0 To n - 1
                        dj = z(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (pk(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                    jj = 0
                    For j = 0 To n - 1
                        dj = pk(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (z(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                    djj = 0
                    For i = 0 To n - 1
                        djj += z(i) * pk(i)
                    Next
                    c /= djj
                    jj = 0
                    For j = 0 To n - 1
                        dj = pk(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) -= (pk(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                Case "DFP-формула"
                    c = 0
                    For i = 0 To n - 1
                        z(i) = yi(i) + alfak * hi(i)
                        c += yi(i) * pk(i)
                    Next
                    c *= alfak
                    jj = 0
                    For j = 0 To n - 1
                        dj = z(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (yi(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                    jj = 0
                    For j = 0 To n - 1
                        dj = yi(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (z(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                    djj = 0
                    For i = 0 To n - 1
                        djj += z(i) * pk(i)
                    Next
                    djj *= alfak
                    c *= c
                    c /= djj
                    jj = 0
                    For j = 0 To n - 1
                        dj = yi(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) -= (yi(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                Case "BFGS-формула"
                    c = 0
                    For i = 0 To n - 1
                        c += hi(i) * pk(i)
                    Next
                    jj = 0
                    For j = 0 To n - 1
                        dj = hi(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (hi(i) * dj / c)
                        Next
                        jj += n - j
                    Next
                    c = 0
                    For i = 0 To n - 1
                        c += yi(i) * pk(i)
                    Next
                    c *= alfak
                    jj = 0
                    For j = 0 To n - 1
                        dj = yi(j)
                        For i = j To n - 1
                            Hijold(jj + i - j) += (yi(i) * dj / c)
                        Next
                        jj += n - j
                    Next
            End Select
            For i = 0 To n - 1
                hi(i) = hi1(i)
            Next
        Next
        If Not berror Then
            Dim dv As New DataView
            With dv
                .Table = globds.idbWyw
                .BeginInit()
                .Table.Clear()
                Dim row As DataRowView
                row = .AddNew()
                Select Case nstop
                    Case 0
                        row(0) = "Останов по близости нормы градиента к нулю"
                    Case 1
                        row(0) = "Останов по числу итераций"
                        k -= 1
                    Case 2
                        row(0) = "Останов по скорости сходимости"
                End Select
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число итераций = " & k
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число вычислений фуккции = " & nf
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений = " & n0
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений = " & no
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число поисков направления отрицательной кривизны = " & ns
                row.EndEdit()
                If balternative Then
                    row = .AddNew()
                    row(0) = "Число переходов к альтернативному направлению спуска = " & na
                    row.EndEdit()
                    row = .AddNew()
                    row(0) = "Число успешных переходов к альтернативному направлению спуска = " & nau
                    row.EndEdit()
                End If
                row = .AddNew()
                row(0) = "число переходов к ньютоновскому направлению спуска = " & mm
                row.EndEdit()
                row = .AddNew()
                row(0) = "Значение функции = " & Fk
                row.EndEdit()
                row = .AddNew()
                row(0) = "Аргументы:"
                row.EndEdit()
                For i = 0 To n - 1
                    row = .AddNew()
                    row(0) = "   x(" & i + 1 & ") = " & xk(i)
                    row.EndEdit()
                Next
                .EndInit()
                .Dispose()
            End With
        End If
    End Sub

End Module
